%define eclipse_base     %{_libdir}/eclipse
%define eclipse_dropin   %{_datadir}/eclipse/dropins/gef
%define gcj_support      1

Name:      eclipse-gef
Version:   3.4.1
Release:   2%{?dist}
Summary:   Graphical Editing Framework (GEF) Eclipse plugin
Group:     System Environment/Libraries
License:   EPL
URL:       http://www.eclipse.org/gef/

# source tarball and the script used to generate it from upstream's source control
# script usage:
# $ sh get-gef.sh
Source0:   gef-%{version}.tar.gz
Source1:   get-gef.sh

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%if %{gcj_support}
BuildRequires:    gcc-java
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%else
BuildArch:        noarch
%endif
BuildRequires:    java-devel
BuildRequires:    jpackage-utils
BuildRequires:    eclipse-pde >= 1:3.4.1
Requires:         java
Requires:         jpackage-utils
Requires:         eclipse-platform >= 1:3.4.1

%description
The Graphical Editing Framework (GEF) allows developers to create a rich
graphical editor from an existing application model. GEF is completely
application neutral and provides the groundwork to build almost any
application, including but not limited to: activity diagrams, GUI builders,
class diagram editors, state machines, and even WYSIWYG text editors.

%package   sdk
Summary:   Eclipse GEF SDK
Group:     System Environment/Libraries
Requires:  %{name} = %{version}-%{release}

%description sdk
Documentation and source for the Eclipse Graphical Editing Framework (GEF).

%package   examples
Summary:   Eclipse GEF examples
Group:     System Environment/Libraries
Requires:  %{name} = %{version}-%{release}
Requires:  %{name}-sdk = %{version}-%{release}

%description examples
Example projects that demonstrate how to use the Eclipse Graphical Editing
Framework (GEF).

%prep
%setup -q -n gef-%{version}

rm -r org.eclipse.gef-feature/sourceTemplateFeature
rm -r org.eclipse.draw2d-feature/sourceTemplateFeature
rm -r org.eclipse.zest-feature/sourceTemplateFeature

# make sure upstream hasn't sneaked in any jars we don't know about
JARS=""
for j in `find -name "*.jar"`; do
  if [ ! -L $j ]; then
    JARS="$JARS $j"
  fi
done
if [ ! -z "$JARS" ]; then
   echo "These jars should be deleted and symlinked to system jars: $JARS"
   exit 1
fi

%build
# build all features
%{eclipse_base}/buildscripts/pdebuild -f org.eclipse.gef.all

%install
rm -rf %{buildroot}
install -d -m 755 %{buildroot}%{eclipse_dropin}
unzip -q -d %{buildroot}%{eclipse_dropin} build/rpmBuild/org.eclipse.gef.all.zip

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf %{buildroot}

%if %{gcj_support}
%post -p %{_bindir}/rebuild-gcj-db
%post sdk -p %{_bindir}/rebuild-gcj-db
%post examples -p %{_bindir}/rebuild-gcj-db
%postun -p %{_bindir}/rebuild-gcj-db
%postun sdk -p %{_bindir}/rebuild-gcj-db
%postun examples -p %{_bindir}/rebuild-gcj-db
%endif

%files
%defattr(-,root,root,-)
%dir %{eclipse_dropin}
%doc %{eclipse_dropin}/eclipse/epl-v10.html
%doc %{eclipse_dropin}/eclipse/notice.html
%doc %{eclipse_dropin}/eclipse/readme
%{eclipse_dropin}/eclipse/content.xml
%{eclipse_dropin}/eclipse/features/org.eclipse.gef_*
%{eclipse_dropin}/eclipse/features/org.eclipse.draw2d_*
%{eclipse_dropin}/eclipse/features/org.eclipse.zest_*
%{eclipse_dropin}/eclipse/plugins/org.eclipse.gef_*
%{eclipse_dropin}/eclipse/plugins/org.eclipse.draw2d_*
%{eclipse_dropin}/eclipse/plugins/org.eclipse.zest.core_*
%{eclipse_dropin}/eclipse/plugins/org.eclipse.zest.layouts_*

%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/org.eclipse.gef_*
%{_libdir}/gcj/%{name}/org.eclipse.draw2d_*
%{_libdir}/gcj/%{name}/org.eclipse.zest.core_*
%{_libdir}/gcj/%{name}/org.eclipse.zest.layouts_*
%endif

%files sdk
%defattr(-,root,root,-)
%doc %{eclipse_dropin}/eclipse/epl-v10.html
%doc %{eclipse_dropin}/eclipse/notice.html
%doc %{eclipse_dropin}/eclipse/readme
%{eclipse_dropin}/eclipse/features/org.eclipse.gef.sdk_*
%{eclipse_dropin}/eclipse/features/org.eclipse.gef.source_*
%{eclipse_dropin}/eclipse/features/org.eclipse.draw2d.sdk_*
%{eclipse_dropin}/eclipse/features/org.eclipse.draw2d.source_*
%{eclipse_dropin}/eclipse/features/org.eclipse.zest.sdk_*
%{eclipse_dropin}/eclipse/features/org.eclipse.zest.source_*
%{eclipse_dropin}/eclipse/plugins/org.eclipse.gef.doc.isv_*
%{eclipse_dropin}/eclipse/plugins/org.eclipse.gef.source_*
%{eclipse_dropin}/eclipse/plugins/org.eclipse.gef.examples.ui.pde_*
%{eclipse_dropin}/eclipse/plugins/org.eclipse.draw2d.doc.isv_*
%{eclipse_dropin}/eclipse/plugins/org.eclipse.draw2d.source_*
%{eclipse_dropin}/eclipse/plugins/org.eclipse.zest.source_*

%if %{gcj_support}
%{_libdir}/gcj/%{name}/org.eclipse.gef.examples.ui.pde_*
%endif

%files examples
%defattr(-,root,root,-)
%doc %{eclipse_dropin}/eclipse/epl-v10.html
%doc %{eclipse_dropin}/eclipse/notice.html
%doc %{eclipse_dropin}/eclipse/readme
%{eclipse_dropin}/eclipse/features/org.eclipse.gef.all_*
%{eclipse_dropin}/eclipse/features/org.eclipse.gef.examples_*
%{eclipse_dropin}/eclipse/plugins/org.eclipse.gef.examples.flow_*
%{eclipse_dropin}/eclipse/plugins/org.eclipse.gef.examples.logic_*
%{eclipse_dropin}/eclipse/plugins/org.eclipse.gef.examples.shapes_*
%{eclipse_dropin}/eclipse/plugins/org.eclipse.gef.examples.source_*
%{eclipse_dropin}/eclipse/plugins/org.eclipse.gef.examples.text_*

%if %{gcj_support}
%{_libdir}/gcj/%{name}/org.eclipse.gef.examples.flow_*
%{_libdir}/gcj/%{name}/org.eclipse.gef.examples.logic_*
%{_libdir}/gcj/%{name}/org.eclipse.gef.examples.shapes_*
%{_libdir}/gcj/%{name}/org.eclipse.gef.examples.text_*
%endif

%changelog
* Mon Dec 22 2008 Mat Booth <fedora@matbooth.co.uk> 3.4.1-2
- Rebuild GCJ DB during post and postun in sub-packages.

* Fri Nov 20 2008 Mat Booth <fedora@matbooth.co.uk> 3.4.1-1
- New maintainer.
- Updated to verion 3.4.1.
- Update package for new Eclipse plugin guidelines.
- Own the gcj/%%{name} directory.
- The 'examples.ui.pde' plugin is actually part of the SDK feature.

* Thu Jul 17 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 3.3.0-3
- fix license tag

* Tue Feb 19 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 3.3.0-2
- Autorebuild for GCC 4.3

* Mon Aug 27 2007 Andrew Overholt <overholt@redhat.com> 3.3.0-1
- 3.3.

* Thu Jun 14 2007 Andrew Overholt <overholt@redhat.com> 3.2.1-5
- Add EPEL5 patches from Rob Myers.

* Tue Jan 30 2007 Andrew Overholt <overholt@redhat.com> 3.2.1-4
- Use copy-platform in %%{eclipse_base}.

* Mon Nov 06 2006 Andrew Overholt <overholt@redhat.com> 3.2.1-3
- Use copy-platform in %%{_libdir}.
- Use binary launcher rather than startup.jar to guard against future
  osgi.sharedConfiguration.area changes.

* Thu Oct 19 2006 Andrew Overholt <overholt@redhat.com> 3.2.1-2
- Fix buildroot (don't know how the wrong one slipped in).

* Thu Oct 19 2006 Andrew Overholt <overholt@redhat.com> 3.2.1-1
- 3.2.1.

* Tue Aug 29 2006 Andrew Overholt <overholt@redhat.com> 3.2.0-2
- First release for Fedora.

* Tue Aug 22 2006 Andrew Overholt <overholt@redhat.com> 3.2.0-1jpp_2rh
- -devel -> -sdk to match upstream..

* Tue Jul 25 2006 Andrew Overholt <overholt@redhat.com> 3.2.0-1jpp_1rh
- 3.2.0.

* Tue May 02 2006 Ben Konrath <bkonrath@redhat.com> 3.1.1-1jpp_2rh
- Remove -debug from compile line.
- Add expamples package.

* Mon Apr 3 2006 Ben Konrath <bkonrath@redhat.com> 3.1.1-1jpp_1rh
- Add devel package. 
- Update sources to 3.1.1.
- Some general spec file cleanup.
- Add patch to stop the gefbuilder plugin from setting bootclasspath.
- Change copyright to license.
- Add instructions for generating source drop.

* Tue Sep 6 2005 Aaron Luchko  <aluchko@redhat.com> 3.1.0-1
- change to match eclipse-changelog.spec and fixed typos

* Thu Aug 4 2005 Aaron Luchko  <aluchko@redhat.com>
- Updated to 3.1.0
- added createTarball.sh, gefSource.sh, and build.xml.patch
- added native build
- changes to use eclipsebuilder
- fixes from Matthias Saou

* Mon Jun 27 2005 Aaron Luchko <aluchko@redhat.com> 3.0.1-8
- Added x86_64

* Mon May 2 2005 Ben Konrath <bkonrath@redhat.com> 3.0.1-7
- Build against Eclipse 3.0.2.

* Thu Mar 31 2005 Phil Muldoon <pmuldoon@redhat.com> 3.0.1-6
- Migrate RHEL-3 sources to RHEL-4

* Mon Nov 1 2004 Phil Muldoon  <pmuldoon@redhat.com> 3.0.1-5
- Stopped ant trying to replace about.mappings

* Mon Nov 1 2004 Phil Muldoon  <pmuldoon@redhat.com> 3.0.1-4
- Changed tar name to new tar

* Mon Nov 1 2004 Phil Muldoon  <pmuldoon@redhat.com> 3.0.1-3
- Touch build scripts to point to 3.0.1

* Mon Nov 1 2004 Phil Muldoon  <pmuldoon@redhat.com> 3.0.1-2
- Explicitly set -DJAVADOC14_HOME=%%{java_home}/bin to build javadocs

* Sun Oct 31 2004 Phil Muldoon <pmuldoon@redhat.com> 3.0.1-1
- Initial Import
